/*
 *	main.c
 *
 *	P/ECEAvP[V̐^iVvCuŁj
 *
 *	* Tue Aug  8 05:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;		/* WbCuŒ`ĂȂ̂ */

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int retval;

	/* hFǂݍ݂܂B */
	thread_lock();
	retval = loadInst();
	thread_unlock();
	if(retval != 0) {
		grcls(3);
		symbol(4, 34, "drum.binǂݍݎsł", 0, 0);
		symbol(4, 44, "h͍Đ܂", 0, 0);
		wait(3000);
		grcls(-1);
	}

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 1,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_STR	"PAUSE!"	/* PAUSEbZ[W */
#define PAUSE_LEN	6		/* PAUSEbZ[W */
#define PAUSE_X		5		/* \ʒu */
#define PAUSE_Y		5		/* \ʒu */

	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;
	unsigned char save[PAUSE_LEN];

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̕ޔB */
				for(i = 0; i < PAUSE_LEN; i++) {
					save[i] = pclSpriteBGGetCharacter(0, PAUSE_X + i, PAUSE_Y);
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̕𕜋AB */
				for(i = 0; i < PAUSE_LEN; i++) {
					pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
				}
			}
			thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
		if(msec() % 1000 < 750) {
			for(i = 0; i < PAUSE_LEN; i++) {
				pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, PAUSE_STR[i]);
			}
		} else {
			for(i = 0; i < PAUSE_LEN; i++) {
				pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
			}
		}
		thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	for(;;) {
		schedule();
	}
	return 0;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	for(;;) {
		schedule();
	}
}
