/*
 *	main.c
 *
 *	VviCg[u
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Wed Dec 4 06:45:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

extern unsigned char KICK1[];
extern unsigned char BOO[];
unsigned char BGM[] = {
#include "free_002.c"
};

/****************************************************************************
 *	L`
 ****************************************************************************/

CHR chr_hart0[] = {		/* Î~n[g */
	{ 0xce, 2, 2, 7, 7 },	/* 0:ʏ   */
	{ 0x20, 2, 2, 7, 7 },	/* 1:#1 */
	{ 0x40, 2, 2, 7, 7 },	/* 2:#2 */
	{ 0x60, 2, 2, 7, 7 },	/* 3:#3 */
};
CHR chr_hart1[] = {		/* ~jn[g */
	{ 0x01, 1, 1, 3, 3 },
};
CHR chr_hart2[] = {		/* ړn[g */
	{ 0x80, 2, 2, 7, 14 },
	{ 0xa0, 2, 2, 7, 14 },
	{ 0xc0, 2, 2, 7, 14 },
	{ 0xe0, 2, 2, 7, 14 },
};
CHR chr_kage[] = {		/* iCg̉e */
	{ 0x10, 2, 1, 7, 4 },
};
CHR chr_panel[][5] = {{		/* pl() */
	{ 0x02, 2, 2, 7, 7 },	/* 0:ʏ   */
	{ 0x22, 2, 2, 7, 7 },	/* 1:]#1 */
	{ 0x42, 2, 2, 7, 7 },	/* 2:]#2 */
	{ 0x62, 2, 2, 7, 7 },	/* 3:]#3 */
	{ 0x82, 2, 2, 7, 7 },	/* 4:]#4 */
	},{			/* pl() */
	{ 0x04, 2, 2, 7, 7 },
	{ 0x24, 2, 2, 7, 7 },
	{ 0x44, 2, 2, 7, 7 },
	{ 0x64, 2, 2, 7, 7 },
	{ 0x84, 2, 2, 7, 7 },
	},{			/* pl() */
	{ 0x06, 2, 2, 7, 7 },
	{ 0x26, 2, 2, 7, 7 },
	{ 0x46, 2, 2, 7, 7 },
	{ 0x66, 2, 2, 7, 7 },
	{ 0x86, 2, 2, 7, 7 },
	},{			/* pl() */
	{ 0x08, 2, 2, 7, 7 },
	{ 0x28, 2, 2, 7, 7 },
	{ 0x48, 2, 2, 7, 7 },
	{ 0x68, 2, 2, 7, 7 },
	{ 0x88, 2, 2, 7, 7 },
}};
CHR chr_waku[][8] = {{		/* g(ʏ) */
	{ 0xa2, 2, 2, 7, 7 },	/* 0: */
	{ 0xa4, 2, 2, 7, 7 },	/* 1:   */
	{ 0xa6, 2, 2, 7, 7 },	/* 2:E */
	{ 0xc2, 2, 2, 7, 7 },	/* 3:   */
	{ 0xc6, 2, 2, 7, 7 },	/* 4:E   */
	{ 0xe2, 2, 2, 7, 7 },	/* 5: */
	{ 0xe4, 2, 2, 7, 7 },	/* 6:   */
	{ 0xe6, 2, 2, 7, 7 },	/* 7:E */
	},{			/* g() */
	{ 0xa8, 2, 2, 7, 7 },
	{ 0xaa, 2, 2, 7, 7 },
	{ 0xac, 2, 2, 7, 7 },
	{ 0xc8, 2, 2, 7, 7 },
	{ 0xcc, 2, 2, 7, 7 },
	{ 0xe8, 2, 2, 7, 7 },
	{ 0xea, 2, 2, 7, 7 },
	{ 0xec, 2, 2, 7, 7 },
}};
CHR chr_knight[][2] = {{	/* ʌ */
	{ 0x0a, 2, 3, 7, 20 },
	{ 0x0c, 2, 3, 7, 20 },
	},{			/* EO */
	{ 0x3a, 2, 3, 7, 20 },
	{ 0x3c, 2, 3, 7, 20 },
	},{			/* O */
	{ 0x6a, 2, 3, 7, 20 },
	{ 0x6c, 2, 3, 7, 20 },
	},{			/*  */
	{ 0x0e, 2, 3, 7, 20 },
	{ 0x3e, 2, 3, 7, 20 },
	},{			/* E */
	{ 0x6e, 2, 3, 7, 20 },
	{ 0x9e, 2, 3, 7, 20 },
}};
CHR chr_scope[] = {		/* Ə */
	{ 0xee, 2, 2, 7, 7 },
};

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define PANEL_COLS	8	/* pľ */
#define PANEL_ROWS	4	/* pl̍s */

typedef struct _PANEL {
	unsigned char color;	/* 0:/1:/2:/3: */
	unsigned char stat;	/* 0:ʏ/1:](p)/2:]() */
	unsigned char cnt;	/* ėpJE^ */
	unsigned char reserved;	/* (gp) */
} PANEL;

#define PHASE_READY1	0	/* "READY!" */
#define PHASE_READY2	1	/* iCgo */
#define PHASE_NORMAL	2	/* ʏ */
#define PHASE_CLEAR1	3	/* n[gړ */
#define PHASE_CLEAR2	4	/* n[gړ */

typedef struct _GI {
	int score;		/* XRA */
	int hole;		/* J */
	int round;		/* Eh(n[g) */

	int phase;		/* tF[Y(PHASE_*) */
	int combo;		/* ݂̘AJ */

	int knight_col;		/* iCǧ݈ʒu() */
	int knight_row;		/* iCǧ݈ʒu(s) */
	int knight_dir;		/* iCǧ(0:4/1:5/2:7/3:8/4:10/5:11/6:1/7:2) */
	int knight_step;	/* ړXebv(8.8bitA0`MAX_STEP) */

	int hart_col;		/* n[g̈ʒu() */
	int hart_row;		/* n[g̈ʒu(s) */
	int hart_anm;		/* n[gAj[VJE^ */

	int scrl_x;		/* BGʂ̃XN[W(X) */
	int scrl_y;		/* BGʂ̃XN[W(Y) */

	PANEL panel[PANEL_ROWS][PANEL_COLS];	/* pl */
} GI;

#define MAX_STEP	(SEC(0.4) << 8)	/* XebvňړH(8.8bit) */
#define MAX_JUMP	24		/* ̍ō_̍[sNZ]   */

int dir_tbl[8][2] = {	/* e[u(4,5,7,8,10,11,1,2) */
	{2,1},{1,2},{-1,2},{-2,1},{-2,-1},{-1,-2},{1,-2},{2,-1}
};

#define MAX_ROUND	10
int spd_tbl[MAX_ROUND + 1] = {	/* Eh̃iCgړx */
	0x019, /*  0:0.100000 */
	0x020, /*  1:0.125900 */
	0x028, /*  2:0.158508 */
	0x033, /*  3:0.199562 */
	0x040, /*  4:0.251248 */
	0x050, /*  5:0.316321 */
	0x065, /*  6:0.398249 */
	0x080, /*  7:0.501395 */
	0x0a1, /*  8:0.631256 */
	0x0cb, /*  9:0.794752 */
	0x100, /* 10:1.000593 */
};
#define ROUND_SPD(r)	(spd_tbl[(r) <= MAX_ROUND ? (r) : MAX_ROUND])

int combo_pts[PANEL_COLS * PANEL_ROWS + 1] = {
	    0,	/* gȂ*/
	   50,	/*  1:h   */
	  100,	/*  2:   */
	  150,	/*  3:~   */
	  200,	/*  4:t@ */
	  250,	/*  5:\   */
	  300,	/*  6:   */
	  350,	/*  7:V   */
	 1000,	/*  8:h   */
	 1100,	/*  9:   */
	 1200,	/* 10:~   */
	 1300,	/* 11:t@ */
	 1400,	/* 12:\   */
	 1500,	/* 13:   */
	 1600,	/* 14:V   */
	 3000,	/* 15:h   */
	 3500,	/* 16:   */
	 4000,	/* 17:~   */
	 4500,	/* 18:t@ */
	 5000,	/* 19:\   */
	 5500,	/* 20:   */
	 6000,	/* 21:V   */
	10000,	/* 22:h   */
	12000,	/* 23:   */
	14000,	/* 24:~   */
	16000,	/* 25:t@ */
	18000,	/* 26:\   */
	20000,	/* 27:   */
	22000,	/* 28:V   */
	30000,	/* 29:h   */
	40000,	/* 30:   */
	50000,	/* 31:~   */
	60000,	/* 32:t@ */
};
int tone_tbl[PANEL_COLS * PANEL_ROWS + 1] = {
	0,	/* gȂ*/
	264,	/*  1:h   */
	297,	/*  2:   */
	330,	/*  3:~   */
	352,	/*  4:t@ */
	396,	/*  5:\   */
	440,	/*  6:   */
	495,	/*  7:V   */
	264*2,	/*  8:h   */
	297*2,	/*  9:   */
	330*2,	/* 10:~   */
	352*2,	/* 11:t@ */
	396*2,	/* 12:\   */
	440*2,	/* 13:   */
	495*2,	/* 14:V   */
	264*4,	/* 15:h   */
	297*4,	/* 16:   */
	330*4,	/* 17:~   */
	352*4,	/* 18:t@ */
	396*4,	/* 19:\   */
	440*4,	/* 20:   */
	495*4,	/* 21:V   */
	264*8,	/* 22:h   */
	297*8,	/* 23:   */
	330*8,	/* 24:~   */
	352*8,	/* 25:t@ */
	396*8,	/* 26:\   */
	440*8,	/* 27:   */
	495*8,	/* 28:V   */
	264*16,	/* 29:h   */
	297*16,	/* 30:   */
	330*16,	/* 31:~   */
	352*16,	/* 32:t@ */
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;		/* WbCuŒ`ĂȂ̂ */

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int hiscore;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void clear_demo();
void gameover_demo();
void panel_work();
int jump_pos(int step);
void field_disp();
void combo_play(int combo);
void hart_play();

/****************************************************************************
 *	BGM{[
 ****************************************************************************/

static int (*old_WaveDataOut)(int ch, PCEWAVEINFO* pwi);

static int new_WaveDataOut(int ch, PCEWAVEINFO* pwi)
{
	short* p;
	int i, len, v;

	if((ch == music_wch) && (pwi->type & PW_TYPE_16BITPCM)) {
		p = (short*)pwi->pData;
		len = pwi->len;
		for(i = 0; i < len; i++) {
			v = *p << 2;
			if(v < -32767) {
				v = -32767;
			} else if(v > 32767) {
				v = 32767;
			}
			*p++ = v;
		}
	}

	return old_WaveDataOut(ch, pwi);
}

static void
hook_WaveDataOut()
{
	if(old_WaveDataOut == NULL) {
		old_WaveDataOut = pceVectorSetKs(KSNO_WaveDataOut, new_WaveDataOut);
	}
}

int
pceAppNotify(int type, int param)
{
extern unsigned char _def_vbuff[];
	switch(type) {
	case APPNF_EXITREQ:
		if(old_WaveDataOut != NULL) {
			pceVectorSetKs(KSNO_WaveDataOut, old_WaveDataOut);
			old_WaveDataOut = NULL;
		}
		break;
	case APPNF_SMSTART:
		return APPNR_ACCEPT;
	case APPNF_SMREQVBUF:
		pceLCDSetBuffer(_def_vbuff);
		return APPNR_ACCEPT;
	}
	return APPNR_IGNORE;
}

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int retval;

	srand(msec());

	thread_lock();
	hook_WaveDataOut();
	pceWaveSetChAtt(0, 0);
	pceWaveSetChAtt(1, 0);
	pceWaveSetChAtt(2, 0);
	pceWaveSetChAtt(3, 0);
	thread_unlock();

	/* hFǂݍ݂܂B */
	thread_lock();
	retval = loadInst();
	thread_unlock();
	if(retval != 0) {
		grcls(3);
		symbol(4, 34, "drum.binǂݍݎsł", 0, 0);
		symbol(4, 44, "h͍Đ܂", 0, 0);
		wait(3000);
		grcls(-1);
	}

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_STR	"PAUSE!"	/* PAUSEbZ[W */
#define PAUSE_LEN	6		/* PAUSEbZ[W */
#define PAUSE_X		5		/* \ʒu */
#define PAUSE_Y		5		/* \ʒu */

	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;
	unsigned char save[PAUSE_LEN];

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̕ޔB */
				for(i = 0; i < PAUSE_LEN; i++) {
					save[i] = pclSpriteBGGetCharacter(0, PAUSE_X + i, PAUSE_Y);
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̕𕜋AB */
				for(i = 0; i < PAUSE_LEN; i++) {
					pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
				}
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
///		if(msec() % 1000 < 750) {
///			for(i = 0; i < PAUSE_LEN; i++) {
///				pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, PAUSE_STR[i]);
///			}
///		} else {
///			for(i = 0; i < PAUSE_LEN; i++) {
///				pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
///			}
///		}
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result;

	/* ʃNAB */
	bgcls();
	grcls(-1);
	spcls(0);

	/* ^Cg\B */
	grputstr(3, 4, "  SIMPLE  ", 3);
	grputstr(3, 5, "KnightMove", 3);

	/* XRA\B */
	grprintf(2,  0, 2, "HI  %08d",  hiscore <= 99999999 ?  hiscore : 99999999);
	grprintf(2,  1, 2, "1P  %08d", gi.score <= 99999999 ? gi.score : 99999999);
	grprintf(0, 10, 2, "ROUND%2d", gi.round <= 99 ? gi.round : 99);
	grprintf(9, 10, 2, "HOLE%3d", gi.hole <= 999 ? gi.hole : 999);

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }

		/* vvg\B */
		grputstr(3, 7, now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ", 2);
		grputstr(3, 8, now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ", 2);
	}
	sound(2);

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
game_init()
{
	memset(&gi, 0, sizeof gi);

	/* iCg̏oʒu߂܂B */
	gi.knight_col = rnd(PANEL_COLS);
	gi.knight_row = rnd(PANEL_ROWS);
	if(gi.knight_col < PANEL_COLS / 2) {
		gi.knight_dir = (1 - gi.knight_row) & 7;
	} else {
		gi.knight_dir = (2 + gi.knight_row) & 7;
	}

	/* n[g̏oʒu߂܂B */
	do {
		gi.hart_col = rnd(PANEL_COLS);
		gi.hart_row = rnd(PANEL_ROWS);
	} while(abs(gi.hart_col - gi.knight_col) <= 2 && /* Xebvňړ\ȋɂ͒uȂ */
	        abs(gi.hart_row - gi.knight_row) <= 2);

	bgcls();
	spcls(0);  /* NAƂ̂ŁAŏɈ񂾂B */
	grcls(-1); /* NAƂ̂ŁAŏɈ񂾂B */
}

void
game()
{
	int i, col, row, spd, accel, vdir;
	PANEL* panel;

	game_init();

	/* "READY!"\B */
	gi.phase = PHASE_READY1;
	for(i = 0; i < SEC(2); i++) {
		schedule();
		gi.knight_step = i << 8;
		field_disp();
		if(i % SEC(0.5) < SEC(0.3)) {
			grputstr(5, 6, "READY!", 3);
		} else {
			grputstr(5, 6, "      ", 3);
		}
	}
	grputstr(5, 6, "      ", 3);

	/* iCgoB */
	gi.phase = PHASE_READY2;
	for(i = DISP_Y / 2; i >= 0; i -= 2) {
		schedule();
		gi.knight_step = i << 8;
		field_disp();
	}

	/* oʒũpl̐Fςĉ]܂B */
	panel = &gi.panel[gi.knight_row][gi.knight_col];
	panel->color++;
	panel->stat = 1;

	/* ʏB */
	gi.phase = PHASE_NORMAL;
	accel = 0;
	ppdplay(KICK1);
	pmdplay(BGM);
	for(;;) {
		schedule();

		/* Jn/IB */
		if(!accel) {
			if(joy & (TRG_A | PAD_B)) accel = 1; /* ɃgKŉJn(BȂ牟ςȂOK) */
		} else {
			if(!(joy & (PAD_A | PAD_B))) accel = 0;
		}

		/* ړxB */
		if(!accel) {
			spd = ROUND_SPD(gi.round);
		} else {
			spd = 1 << 8;
			gi.score++; /* ̓XRAAbv */
		}

		/* ]B */
		vdir = 0;
		if(joy & TRG_RI) vdir++;
		if(joy & TRG_LF) vdir--;
		if(vdir) {
			sound(vdir < 0 ? 1 : 3);
			for(;;) {
				gi.knight_dir = (gi.knight_dir + vdir) & 7;
				col = gi.knight_col + dir_tbl[gi.knight_dir][0];
				row = gi.knight_row + dir_tbl[gi.knight_dir][1];
				if(0 <= col && col <= PANEL_COLS - 1 &&
				   0 <= row && row <= PANEL_ROWS - 1) break;
			}
		}

		/* ړB */
		gi.knight_step += spd;
		if(gi.knight_step >= MAX_STEP) {
			pceWaveAbort(2); /* mɃR{~Ă */

			/* iCg̈ʒuύXB */
			accel = 0; /* nɉ */
			gi.knight_col += dir_tbl[gi.knight_dir][0];
			gi.knight_row += dir_tbl[gi.knight_dir][1];
			gi.knight_step = 0;
			/* ܂]܂ */

			/* Spl̏ԂB */
			for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
				for(col = 0; col < PANEL_COLS; col++, panel++) {
					panel->stat = 0;
					panel->cnt = 0;
				}
			}

			/* H */
			panel = &gi.panel[gi.knight_row][gi.knight_col];
			if(panel->color == 3) goto GAMEOVER;

			/* nn_̃pl̐Fς܂B */
			gi.scrl_y -= 4; /* nU */
			panel->color++;
			if(panel->color == 3) {
				gi.hole++; /* JAbv */
				gi.combo++; /* R{EAbv */
				gi.score += combo_pts[gi.combo]; /* _Z */
				combo_play(gi.combo); /* R{̉ */
				ppdplay(KICK1); /* R{̉̃A^bN */
			} else {
				if(gi.combo == 0 || gi.combo >= 8) { /* R{łȂAR{ */
					ppdplay(KICK1);
				} else { /* R{s */
					ppdplay(BOO);
				}
				gi.combo = 0; /* R{ENA */
			}

			/* ܂](stat<-1)܂B
			 * ̒nɂČJ(color=3)An[g𓥂񂾏ꍇA
			 * ̌An[gɂpl](stat<-2)邩B
			 */

			/* n[g𓥂񂾁H */
			if(gi.knight_col == gi.hart_col && gi.knight_row == gi.hart_row) {
				/* EhAbvB */
				sound(2);
				gi.round++;
				clear_demo();

				/* ̃n[g̈ʒu߂܂B */
				do {
					gi.hart_col = rnd(PANEL_COLS);
					gi.hart_row = rnd(PANEL_ROWS);
				} while(abs(gi.hart_col - gi.knight_col) <= 2 && /* Xebvňړ\ȋɂ͒uȂ */
				        abs(gi.hart_row - gi.knight_row) <= 2);
			}

			/* nn_̃pl]܂B */
			panel->stat = 1;

			/* ̒̏B */
			gi.knight_dir ^= 4; /* 180x] */
			gi.knight_step = 0;

			/* JnɃn[gB */
			gi.hart_anm = 0;
		}

		gi.hart_anm++;
		panel_work();
		field_disp();
	}
GAMEOVER:
	pmdstop();
	gameover_demo();
	if(gi.score > hiscore) hiscore = gi.score; /* nCXRAXVH */
}

/****************************************************************************
 *	clear_demo
 ****************************************************************************/

void
clear_demo()
{
	int i, col, row;
	PANEL* panel;

	/* n[gюUB */
	gi.phase = PHASE_CLEAR1;
	for(i = 0; i < SEC(0.5); i++) {
		schedule();
		gi.hart_anm = i * 2;
		panel_work();
		field_disp();
	}

	/* ʑŜړ... */
	gi.phase = PHASE_CLEAR2;
	gi.hart_anm = 0;
	for(col = 0; col < PANEL_COLS; col++) {
		for(row = 0; row < PANEL_ROWS; row++) {
			panel = &gi.panel[row][col];
			hart_play();
			gi.hart_col = col;
			gi.hart_row = row;
			if(panel->color == 3) { /* JplȂ... */
				panel->color = 0; /* plɖ߂... */
				panel->stat = 2; /* ] */
			}
			for(i = 0; i < SEC(0.15); i++) {
				schedule();
				gi.hart_anm++;
				panel_work();
				field_disp();
			}
		}
	}
	pceWaveAbort(2); /* n[g~ */

	gi.phase = PHASE_NORMAL;
}

/****************************************************************************
 *	gameover_demo
 ****************************************************************************/

void
gameover_demo()
{
	int obj, i, x, y;

	bgcls();
	spcls(0);
	grcls(-1);

	ppdplay(BOO);

	for(y = 0; y < 32; y++) {
		for(x = 0; x < 32; x++) {
			bgput(x, y, 0x99); /* pl̂܂땔𗬗p */
		}
	}
	grputstr(4, 5, "GAMEOVER", 0);

	/* XRAEEhEJ\B */
	grprintf(4,  0, 0, "%08d", gi.score <= 99999999 ? gi.score : 99999999);
	grprintf(0, 10, 0, "ROUND%2d", gi.round <= 99 ? gi.round : 99);
	grprintf(9, 10, 0, "HOLE%3d", gi.hole <= 999 ? gi.hole : 999);

	i = 0;
	for(y = 0; y < DISP_Y + 24; y += 2) {
		schedule();
		obj = 0;
		obj = chdisp(obj, DISP_X / 2, y, chr_knight[1 + (i / 2 & 3)]);
		spcls(obj);
		i++;
	}
}

/****************************************************************************
 *	panel_work
 ****************************************************************************/

void
panel_work()
{
	int col, row;
	PANEL* panel;

	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			if(!panel->stat) continue;
			panel->cnt++;
			if(panel->stat == 2) { /* ] */
				if(panel->cnt >= 8 * 2) {
					panel->stat = 0;
					panel->cnt = 0;
				}
			}
		}
	}
}

/****************************************************************************
 *	jump_pos
 ****************************************************************************/

/* Nɒ̍e[u쐬ƁA\b߂Ă܂̂ŁAsɍ쐬܂B
 * l͕ۑ̂ŁAXebvlł̓ڈȍ~̗v́APȃe[uQƂɂȂ܂B
 */
int
jump_pos(int step)
{
	static unsigned char pos_tbl[MAX_STEP]; /* rs`shbłI */
	int pos;

	/* Ô߁AXebvl͈̔̓I[o[B(TODO:肵O) */
	if(step < 0 || MAX_STEP - 1 < step) DIE();

	/* ŏ̈񂾂A̍vZ܂B */
	pos = pos_tbl[step];
	if(pos == 0) {
		pos = sin(PI * step / MAX_STEP) * MAX_JUMP;
		pos_tbl[step] = 0x80 | pos;
	}
	return pos & 0x7f;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static unsigned char ptn_panel_spin[8] = { 0,1,2,3,4,3,2,1 };
static unsigned char ptn_knight_dir[8] = { 1,1,2,2,3,3,4,4 };

void
field_disp()
{
	int obj, ptn, col, row, x, y;
	int knight_x, knight_y, knight_h, scope_x, scope_y, hart_x, hart_y, cent_x, cent_y;
	PANEL* panel;
	CHR* chr;

	obj = 0;

	/* XN[ݒB */
	bgscrl(gi.scrl_x, gi.scrl_y);

	/* g`܂B */
	if(gi.combo >= 8) {
		ptn = now & 2 ? 1 : 0;
	} else {
		ptn = 0;
	}
	bgdisp(0                 , 0                 , &chr_waku[ptn][0]);
	bgdisp(2 + 2 * PANEL_COLS, 0                 , &chr_waku[ptn][2]);
	bgdisp(0                 , 2 + 2 * PANEL_ROWS, &chr_waku[ptn][5]);
	bgdisp(2 + 2 * PANEL_COLS, 2 + 2 * PANEL_ROWS, &chr_waku[ptn][7]);
	for(col = 0; col < PANEL_COLS; col++) {
		bgdisp(2 + 2 * col, 0                 , &chr_waku[ptn][1]);
		bgdisp(2 + 2 * col, 2 + 2 * PANEL_ROWS, &chr_waku[ptn][6]);
	}
	for(row = 0; row < PANEL_ROWS; row++) {
		bgdisp(0                 , 2 + 2 * row, &chr_waku[ptn][3]);
		bgdisp(2 + 2 * PANEL_COLS, 2 + 2 * row, &chr_waku[ptn][4]);
	}

	/* pl`܂B */
	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			chr = &chr_panel[panel->color][0];
			if(panel->stat) { /* 1or2:] */
				ptn = panel->cnt / 2 & 7;
				chr += ptn_panel_spin[ptn];
			}
			bgdisp(2 + 2 * col, 2 + 2 * row, chr);
		}
	}

	/* iCgƏƏ̈ʒu߂܂B */
	knight_x = 16 + 16 * gi.knight_col + 7;
	knight_y = 16 + 16 * gi.knight_row + 7;
	knight_h = 0; /* x} */
	x = dir_tbl[gi.knight_dir][0] * 16;
	y = dir_tbl[gi.knight_dir][1] * 16;
	scope_x = knight_x + x;
	scope_y = knight_y + y;
	switch(gi.phase) {
	case PHASE_READY1:
	case PHASE_READY2:
		knight_h = gi.knight_step >> 8;
		break;
	case PHASE_NORMAL:
	case PHASE_CLEAR1:
	case PHASE_CLEAR2:
		x = x * gi.knight_step / MAX_STEP;
		y = y * gi.knight_step / MAX_STEP;
		knight_x += x;
		knight_y += y;
		knight_h = jump_pos(gi.knight_step);
		break;
	}

	/* Ə`܂B */
	switch(gi.phase) {
	case PHASE_NORMAL: /* ʏړ̂ */
		x = scope_x - gi.scrl_x;
		y = scope_y - gi.scrl_y;
		obj = chdisp(obj, x, y, &chr_scope[0]);
		break;
	}

	/* e`܂B */
	switch(gi.phase) {
	case PHASE_READY1:
		/* ܂iCgoĂ܂B */
		break;
	default:
		x = knight_x - gi.scrl_x;
		y = knight_y - gi.scrl_y;
		obj = chdisp(obj, x, y, &chr_kage[0]);
		break;
	}

	/* n[g`܂B */
	hart_x = 16 + 16 * gi.hart_col + 7;
	hart_y = 16 + 16 * gi.hart_row + 7;
	switch(gi.phase) {
	case PHASE_READY1:
	case PHASE_READY2:
		/* ړJnO̓n[g\܂B */
		break;
	case PHASE_NORMAL:
		if(gi.hart_anm < 2 * 4) {
			ptn = gi.hart_anm / 2 & 3; /* iCgň */
		} else {
			ptn = 0;
		}
		chr = &chr_hart0[ptn];
		x = hart_x - gi.scrl_x;
		y = hart_y - gi.scrl_y;
		obj = chdisp(obj, x, y, chr);
		break;
	case PHASE_CLEAR1:
		chr = &chr_hart1[0];
		x = hart_x - gi.scrl_x;
		y = hart_y - gi.scrl_y;
		obj = chdisp(obj, x - gi.hart_anm, y - gi.hart_anm, chr);
		obj = chdisp(obj, x + gi.hart_anm, y - gi.hart_anm, chr);
		obj = chdisp(obj, x + gi.hart_anm, y + gi.hart_anm, chr);
		obj = chdisp(obj, x - gi.hart_anm, y + gi.hart_anm, chr);
		break;
	case PHASE_CLEAR2:
		ptn = gi.hart_anm / 2 & 3;
		chr = &chr_hart2[ptn];
		x = hart_x - gi.scrl_x;
		y = hart_y - gi.scrl_y;
		obj = chdisp(obj, x, y, chr);
		break;
	}

	/* iCg`܂B */
	switch(gi.phase) {
	case PHASE_READY1:
		/* ܂iCgoĂ܂B */
		break;
	default:
		ptn = gi.knight_step >> 8 & 1;
		if(gi.phase == PHASE_READY2) {
			chr = &chr_knight[0][ptn];
		} else {
			chr = &chr_knight[ptn_knight_dir[gi.knight_dir]][ptn];
		}
		x = knight_x -            gi.scrl_x;
		y = knight_y - knight_h - gi.scrl_y;
		obj = chdisp(obj, x, y, chr);
		break;
	}

	/* XRAEEhEJ\B */
	grprintf(4,  0, 3, "%08d", gi.score <= 99999999 ? gi.score : 99999999);
	grprintf(0, 10, 3, "ROUND%2d", gi.round <= 99 ? gi.round : 99);
	grprintf(9, 10, 3, "HOLE%3d", gi.hole <= 999 ? gi.hole : 999);

	/* NAbṽ|Cg\B */
	if(gi.combo != 0) {
		grprintf(3, 8, 3 - (now & 3), "%6d PTS", combo_pts[gi.combo]);
	} else {
		grputstr(3, 8, "          ", 0);
	}

	/* ̃XN[ʒu𒲐B */
	switch(gi.phase) {
	case PHASE_READY1: /* iCgo͉ʒɌŒ */
		gi.scrl_x = -(DISP_X - 16 * (PANEL_COLS + 2)) / 2;
		gi.scrl_y = -(DISP_Y - 16 * (PANEL_ROWS + 2)) / 2;
		break;
	default:
		if(gi.phase == PHASE_CLEAR2) {	/* NAf̓n[gǐ(㉺͌Œ) */
			cent_x = hart_x;
			cent_y = DISP_Y / 2;
		} else {			/* ȊO̓iCgǐ */
			cent_x = knight_x;
			cent_y = knight_y;
		}
		x = (gi.scrl_x * 13 + (cent_x - DISP_X / 2) * 3) / 16;
		if(x != gi.scrl_x) {
			gi.scrl_x = x;
		} else { /* ǐՖڕWɋ߂ꍇ1sNZÂǐ */
			if(gi.scrl_x < cent_x - DISP_X / 2) {
				gi.scrl_x++;
			} else if(gi.scrl_x > cent_x - DISP_X / 2) {
				gi.scrl_x--;
			}
		}
		y = (gi.scrl_y * 13 + (cent_y - DISP_Y / 2) * 3) / 16;
		if(y != gi.scrl_y) {
			gi.scrl_y = y;
		} else { /* ǐՖڕWɋ߂ꍇ1sNZÂǐ */
			if(gi.scrl_y < cent_y - DISP_Y / 2) {
				gi.scrl_y++;
			} else if(gi.scrl_y > cent_y - DISP_Y / 2) {
				gi.scrl_y--;
			}
		}
		break;
	}

	spcls(obj);
}

/****************************************************************************
 *	combo_play/hart_play
 ****************************************************************************/

static PCEWAVEINFO wi;
static unsigned char wbuff[1024];

void
combo_play(int combo)
{
	int i, step, cur;
	unsigned char* p;

	pceWaveAbort(2);

	memset(&wi, 0, sizeof wi);
	wi.type = PW_TYPE_8BITPCM;
	wi.pData = wbuff;
	wi.len = 1024;
	if(combo >= 8) wi.next = &wi;
	cur = 0;
	step = tone_tbl[combo] << 16 / 16000;
	for(p = wbuff, i = 0; i < 1024; i++, p++) {
		*p = cur & 1 << 14 ? 255 - i / 4 : 0; /* Ȃ128𒆉ɂƉ{P */
		cur += step;
	}

	pceWaveDataOut(2, &wi);
}

void
hart_play()
{
	int i, step, cur;
	unsigned char* p;

	pceWaveAbort(2);

	memset(&wi, 0, sizeof wi);
	wi.type = PW_TYPE_8BITPCM;
	wi.pData = wbuff;
	wi.len = 512;
	cur = 0;
	step = tone_tbl[1 + rnd(7)] * 8 << 16 / 16000;
	for(p = wbuff, i = 0; i < 512; i++, p++) {
		*p = cur & 1 << 14 ? 128 - i / 4 : 0; /* Ȃ128𒆉ɂƉ{P */
		cur += step;
	}

	pceWaveDataOut(2, &wi);
}
